Const ScrFile="berech.prg",iniFile="berech.ini",iniSection="Settings",ScrVersion=8
Const cCross=1,cTabs=1,cWrapX=1
Const cColorSet=024,cColorKvuza=400

FUNC d_main()
int i,set_count,kvuza_count,iClr[2]
string sMsg,s,t
sMsg:="RavText failed to load"
if var("d_berech","dlog") then SetIniFile_pos("d_berech","DialogXY")
if not isglobal("ravbox") then
	if activetext() then run file "ravtxt.lib"
	if not isglobal("ravbox") then return MsgReturn(sMsg,1,0)
end if
if not inited then run ravinit
if not lib_() then return 0
s:=" it st=e,d al=r bo=0,0 HS=0 VS=0 la='',2001" ; dir retrieval
s+=" it st=p bo=29 al=f la=' |run file \""+ScrFile+"\" func \"NewSet_d\"',3"
s+=" it st=p bo=43 al=a la=' |run file \""+ScrFile+"\" func \"NewKvuza_d\"',4"
s+=" it ca='^. '"
set_count:=GetFS(iniSection,"set_count","")
for i:=1 to set_count do
	if Set_(t:=i,0) then
		t:="^! "+rStr(t)+"^!: "+rStr(GetFS("set "+t,"shem"," "))
		s+=" it st=t bo=200,8 al=r la='^r"+t+"',"+(t:=100+i)
	end if
end for
if (kvuza_count:=GetFS(iniSection,"kvuza_count","")) then s+=" it ca='^. '"
for i:=1 to kvuza_count do
	if Kvuza_(t:=i,0) then
		t:="^! "+rStr(t)+"^!: "+rStr(GetFS("kvuza "+t,"shem"," "))
		s+=" it st=t bo=200,8 al=r la='^r"+t+"',"+(t:=200+i)
	end if
end for
s+=" it ca='^. '"
s+=" it st=p bo=47 al=f la=' |run file \""+ScrFile+"\" func \"Berech_a\"',1,f"
s+=" it st=p bo=25 al=a la='|run file \""+ScrFile+"\" func \"Quit_d\"',2"
DIALOG "d_berech" QUIETMODE TEMPLATE "dlog heb ti='' bo=85"+s ID LibFunc(ravinit,"GetAppID")^()
iClr[0]:=s:=GetFS(iniSection,"color",cColorSet)
if (i:=end find(",",0,s))>-1 then iClr[1]:=tail(i,s) else iClr[1]:=cColorKvuza
for i:=1 to set_count do
	setdlgscript(d_berech,i+100,"run file \""+ScrFile+"\" func \"d_set\"")
	setdlgtext(d_berech,i+100,GetDlgColor(iClr[0]))
end for
for i:=1 to kvuza_count do
	setdlgscript(d_berech,i+200,"run file \""+ScrFile+"\" func \"d_kvuza\"")
	setdlgtext(d_berech,i+200,GetDlgColor(iClr[1]))
end for
setdlgtext(d_berech,2001,directory),GetIniFile_pos("d_berech","DialogXY")
END FUNC

FUNC Quit_d()
SetIniFile_pos("d_berech","DialogXY")
close d_berech,var("BRC_0","lib")
END FUNC

FUNC d_set()
int id_dlg,id_set
id_set:=dlghit() mod 100
if not TagVersion_(3.93) then goto X0
if (id_dlg:=KeyDown("CTRL")) then goto X0
if (id_dlg:=KeyDown("SHIFT")*3) then goto X0
X0: d_set0(id_dlg,id_set)
END FUNC

FUNC d_set0(id_dlg,id_set)
int set_count,i
string s,t
t:=id_set
if id_dlg then goto X1
s:=" it st=p bo=30 co=2 al=c la='',3,'',4,'',1,f,'',2"
DIALOG "d_berech_set" QUIETMODE TEMPLATE \
	"dlog heb ti='"+rStr(" "+rStr(t))+"' bo=80"+s
GetIniFile_pos("d_berech_set","DialogXY:Set")
id_dlg:=modaldlg(d_berech_set,1)
SetIniFile_pos("d_berech_set","DialogXY:Set")
close var("d_berech_set","dlog")
X1:	if id_dlg=1 then Berech_s(id_set,id_set)
	if id_dlg=3 then if d_SetInfo(id_set) then
		if not Set_(id_set,1) then goto X0
		setdlgtext(d_berech,id_set+100,"^! "+rStr(t)+"^!: "+rStr(GetFS("set "+t,"shem"," ")))
	end if
	if id_dlg=4 then
		SetFS("set "+t,0,0,1)
X0:		if (id_set=(set_count:=GetFS(iniSection,"set_count",""))) then
			for i:=set_count-1 downto 1 do if Set_(t:=i,0) then break
			SetFS(iniSection,"set_count",t:=i,0)
		end if
		d_main()
	end if
END FUNC

FUNC NewSet_d()
int set_count,i
string s
set_count:=GetFS(iniSection,"set_count","")
for i:=1 to set_count do if not Set_(s:=i,0) then break
if d_SetInfo(i) then if Set_(s:=i,1) then
	if i>set_count then SetFS(iniSection,"set_count",s:=i,0)
	d_main()
end if
END FUNC

FUNC d_SetInfo(id_set)
int id_dlg,iReturn
string sRecord[2],s,t
s:=" it st=t,d bo=15,10 al=f la=':'"
	s+=" it st=e fi=h bo=60,10 al=a la='',10,f"
s+=" it ca='^. '"
s+=" it st=t,d bo=27,10 al=f la=':'"
s+=" it st=e fi=dmsap bo=10,10 co=4 al=a HS=2 la='',101,'',102,'',103,'',104"
s+=" it st=t,d bo=27,10 al=f la=':'"
s+=" it st=e fi=dmsap bo=10,10 co=4 al=a HS=2 la='',201,'',202,'',203,'',204"
s+=" it st=t,d bo=27,10 al=f la=':'"
s+=" it st=e fi=dmsap bo=10,10 co=4 al=a HS=2 la='',301,'',302,'',303,'',304"
s+=" it st=c bo=70,8 al=l la='   ',401"
s+=" it st=c bo=70,8 al=l la='   ',402"
s+=" it st=t,d,m bo=40,16 al=l la='^r   '"
	s+=" it st=e fi=dmsap bo=20,14 al=a la='',403"
s+=" it st=p bo=80 al=c la='   ',3"
s+=" it st=p bo=38 al=c la='',1"
s+=" it st=p bo=38 al=a la='|close d_berech_SetInfo',2"
DIALOG "d_berech_SetInfo" QUIETMODE TEMPLATE \
	"dlog heb ti='"+rStr("  "+rStr(t:=id_set))+"' bo=90"+s
GetIniFile_Info("set "+t,""),GetIniFile_pos("d_berech_SetInfo","DialogXY:SetInfo")
sRecord[0]:="   ",sRecord[1]:="===    ==="
X2:	setdlgtext(d_berech_SetInfo,3,sRecord[0])
	id_dlg:=modaldlg(d_berech_SetInfo,1)
X3:	if id_dlg=1 then goto X0
	if id_dlg=2 then goto X1
	if id_dlg=3 then
		if getdlgtext(d_berech_SetInfo,3)=sRecord[1] then goto X2
		global pointer "ppg"
		global int "nPg"
		if not GetPage_(@ppg,@nPg,1,0) then
			close ppg,nPg
			goto X2
		end if
		setdlgtext(d_berech_SetInfo,3,sRecord[1]),ClearSetInfo_d()
		global int "n_count"
		clickhandler FILE ScrFile FUNC "c_handler"
		show ppg^
		PageChange ppg^ ID 0 SETSEL CURSOR 0
		id_dlg:=modaldlg(d_berech_SetInfo,1,ppg^)
		PageChange ppg^ ID 0 SETSEL CURSOR 1
		clickhandler FILE "ravbox.lib" FUNC "c_handler" DOUBLE
		close ppg,nPg,n_count
		goto X3
	else goto X1
	end if
X0:	iReturn:=SetIniFile_Info("set "+t,"")
X1:	SetIniFile_pos("d_berech_SetInfo","DialogXY:SetInfo")
	close var("d_berech_SetInfo","dlog")
	show var("d_berech","dlog")
return iReturn
END FUNC

FUNC c_handler()
int id_box[2],i,j
real r[3]
boolean b[256]
string s
if not (var("ppg","gvar") and var("nPg","gvar") and addr var("n_count","gvar")) then return
id_box[0]:=getpasteinfo("mouse",r,0,ppg^)
if not id_box[0] then goto X0
getpasteinfo("selection",b,0,ppg^)
for i:=id_box[1]:=0 to 255 do
	if b[i] then
		id_box[1]:=getpasteinfo("id",b,i*-1,ppg^)
		break
	end if
end for
if not (id_box[0]=id_box[1]) then goto X0
if not GetBoxInfo0(ppg,nPg,id_box[0],r[2],r) then
X0:	beep -2
	return
end if
if n_count then if not (n_count mod 4) then ClearSetInfo_d()
for i:=1 to 3 do setdlgtext(d_berech_SetInfo,100*i+(n_count mod 4)+1,s:=j:=r[i-1])
if not ((n_count+=1) mod 4) then beep -3
END FUNC

FUNC GetBoxInfo0(ppg,nPg,id_box,n_line,varResult)
int xID,xFormat,xElements,id_text,pos,nLines,i
select boxSel[8]
pointer ptxt
for id_text:=0 to text_count-1 do if kvutsa_textids[id_text]=id_box then break
if id_text<text_count then varResult[0]:=id_box else return 0
GetTextBox ppg^ ID (xID:=id_box) FORMAT xFormat ELEMENTS xElements
varResult[1]:=xFormat+1
if not (ptxt:=addr var(str_text_info[id_text,1],"text")) then \
	return MsgReturn("text not open",0,0)
pos:=GetPgPos(nPg,getpage(tail(prevpage(end ptxt^,ptxt^),ptxt^)),ptxt)
just this page of range(pos,pos,ptxt^) OUTSEL boxSel NOJUST
for i:=0 to xElements-1 do \
	if (n_line<=(nLines+=linecount(boxSel[i]^))) then break
if i<xElements then varResult[2]:=i+1 else return 0
return 1
END FUNC

FUNC ClearSetInfo_d()
int i,j
for i:=1 to 3 do for j:=1 to 4 do setdlgtext(d_berech_SetInfo,100*i+j,"")
END FUNC

FUNC d_kvuza()
int id_dlg,id_kvuza
id_kvuza:=dlghit() mod 100
if not TagVersion_(3.93) then goto X0
if (id_dlg:=KeyDown("CTRL")) then goto X0
if (id_dlg:=KeyDown("SHIFT")*3) then goto X0
X0: d_kvuza0(id_dlg,id_kvuza)
END FUNC

FUNC d_kvuza0(id_dlg,id_kvuza)
int kvuza_count,i
string s,t
t:=id_kvuza
if id_dlg then goto X1
s:=" it st=p bo=30 co=2 al=c la='',3,'',4,'',1,f,'',2"
DIALOG "d_berech_kvuza" QUIETMODE TEMPLATE \
	"dlog heb ti='"+rStr(" "+rStr(t))+"' bo=80"+s
GetIniFile_pos("d_berech_kvuza","DialogXY:Kvuza")
id_dlg:=modaldlg(d_berech_kvuza,1)
SetIniFile_pos("d_berech_kvuza","DialogXY:Kvuza")
close var("d_berech_kvuza","dlog")
X1:	if id_dlg=1 then Berech_k(id_kvuza,id_kvuza)
	if id_dlg=3 then if d_KvuzaInfo(id_kvuza) then
		if not Kvuza_(id_kvuza,1) then goto X0
		setdlgtext(d_berech,id_kvuza+200,"^! "+rStr(t)+"^!: "+rStr(GetFS("kvuza "+t,"shem"," ")))
	end if
	if id_dlg=4 then
		SetFS("kvuza "+t,0,0,1)
X0:		if (id_kvuza=(kvuza_count:=GetFS(iniSection,"kvuza_count",""))) then
			for i:=kvuza_count-1 downto 1 do if Kvuza_(t:=i,0) then break
			SetFS(iniSection,"kvuza_count",t:=i,0)
		end if
		d_main()
	end if
END FUNC

FUNC NewKvuza_d()
int kvuza_count,i
string s
kvuza_count:=GetFS(iniSection,"kvuza_count","")
for i:=1 to kvuza_count do if not Kvuza_(s:=i,0) then break
if d_KvuzaInfo(i) then if Kvuza_(s:=i,1) then
	if i>Kvuza_count then SetFS(iniSection,"Kvuza_count",s:=i,0)
	d_main()
end if
END FUNC

FUNC d_KvuzaInfo(id_kvuza)
int id_dlg,iReturn
string s,t
s:=" it st=t,d bo=18,10 al=f la=':'"
	s+=" it st=e fi=h bo=57,10 al=a la='',10,f"
s+=" it st=t,d bo=18,10 al=f la=':'"
	s+=" it st=e fi=da bo=57,10 al=a la='',11"
s+=" it st=p bo=38 al=f la='',1"
s+=" it st=p bo=38 al=a la='|close d_berech_KvuzaInfo',2"
DIALOG "d_berech_KvuzaInfo" QUIETMODE TEMPLATE \
	"dlog heb ti='"+rStr("  "+rStr(t:=id_kvuza))+"' bo=90"+s
GetIniFile_Info("","kvuza "+t),GetIniFile_pos("d_berech_KvuzaInfo","DialogXY:KvuzaInfo")
id_dlg:=modaldlg(d_berech_KvuzaInfo,1)
if id_dlg=1 then iReturn:=SetIniFile_Info("","kvuza "+t)
SetIniFile_pos("d_berech_KvuzaInfo","DialogXY:KvuzaInfo")
close var("d_berech_KvuzaInfo","dlog")
show var("d_berech","dlog")
return iReturn
END FUNC

; ---------------------------------------------------------------------------------------------------

FUNC Berech_a()
Berech_a0(1,1)
END FUNC

FUNC Berech_a0(bMsg,bExit)
return Berech_a1(0,bMsg,bExit)
END FUNC

FUNC Berech_a1(nMask,bMsg,bExit)
int set_count
set_count:=GetFS(iniSection,"set_count","")
return Berech_m(1,set_count,0,"",nMask,bMsg,bExit)
END FUNC

FUNC Berech_s(iStart,iEnd)
Berech_s0(iStart,iEnd,1,1)
END FUNC

FUNC Berech_s0(iStart,iEnd,bMsg,bExit)
return Berech_m(iStart,iEnd,0,"",0,bMsg,bExit)
END FUNC

FUNC Berech_k(iStart,iEnd)
Berech_k0(iStart,iEnd,1,1)
END FUNC

FUNC Berech_k0(iStart,iEnd,bMsg,bExit)
return Berech_m(iStart,iEnd,1,"",0,bMsg,bExit)
END FUNC

FUNC Berech_list(sList)
Berech_list0(sList,1,1)
END FUNC

FUNC Berech_list0(sList,bMsg,bExit)
return Berech_m(0,-1,0,sList,0,bMsg,bExit)
END FUNC

FUNC Berech_list1(sList,nMask,bMsg,bExit)
return Berech_m(0,-1,0,sList,nMask,bMsg,bExit)
END FUNC

FUNC Berech_m(iStart,iEnd,bKvuza,sList,nMask,bMsg,bExit) ; LC/RTA=pLib
int nPg,pos,set_count,i,j,k
pointer ppg,pLib
string s,t
if not GetPage_(@ppg,@nPg,bMsg,bExit) then return 0
if not GetMask(nMask,1) then if (pLib:=GetLib()) then pLib^(0)
set_count:=GetFS(iniSection,"set_count","")
if (t:=sList) then goto X0
if bKvuza then
	for k:=iStart to iEnd do
		if not (t:=GetFS("kvuza "+(s:=k),"sets","")) then continue
X0:		while len(t) do
			if (pos:=end find(",",0,t))>-1 then \
				i:=s:=range(0,pos-1,t),t:=tail(pos,t) else i:=s:=t,t:=""
			if (pos:=end find("-","r",s))=-1 then j:=i else if not (j:=tail(pos,s)) then j:=set_count
			for i:=i to j do Berech_set(i,ppg,nPg)
		end while
	end for
else for i:=iStart to iEnd do Berech_set(i,ppg,nPg)
end if
if pLib then pLib^(3)
return 1
END FUNC

FUNC Berech_set(n_set,ppg,nPg)
int set_info[3,4],n_obj[5],n_text[4],n_format[4],n_box[4],i,j
real min_space
boolean bSwap,bAll,bCross,bTabs,bWrapX
string s,t
if not n_set then return
if not (s:=GetFS(t:="set "+(t:=n_set),"text","")) then return
n_obj[4]:=inSplit(s,",",set_info,0,0,-1,-1)-1
s:=GetFS(t,"format",""),inSplit(s,",",set_info,1,0,-1,-1)
s:=GetFS(t,"box",""),inSplit(s,",",set_info,2,0,-1,-1)
for i:=1 to 2 do for j:=0 to n_obj[4] do if set_info[i,j]>0 then set_info[i,j]-=1
for i:=j:=0 to n_obj[4] do n_obj[i]:=i
if not odd(nPG) then if (bSwap:=GetAltFS(t,iniSection,"swap")) then \
	for i:=n_obj[4] downto 0 do n_obj[j]:=i,j+=1
for i:=0 to n_obj[4] do \
	n_text[i]:=set_info[0,n_obj[i]],n_format[i]:=set_info[1,n_obj[i]],n_box[i]:=set_info[2,n_obj[i]]
bAll:=GetAltFS(t,iniSection,"all"),min_space:=GetAltFS(t,iniSection,"min_space")
bCross:=GetAltFS_(t,iniSection,"cross",cCross),bTabs:=GetAltFS_(t,iniSection,"tabs",cTabs)
bWrapX:=GetAltFS_(t,iniSection,"wrap_x",cWrapX)
Berech_f(ppg,nPg,n_obj[4],n_text,n_format,n_box,bAll,min_space,bCross,bTabs,bWrapX)
END FUNC

FUNC Berech_f(ppg,nPg,n_obj,n_text,n_format,n_box,bAll,min_space,bCross,bTabs,bWrapX)
; textbox var's
int xElements[10]
real xBox[9,30]
; script var's
int n_element,iElementIT[9,2],iRight,iLeft,n_DP,n_reflow[5],id_text[4],id_[2,4],pos,i,j,k,n
real rTopDP[4],rBoxDP[4],rTotalDP[4],rKotDP[4],rContDP[4],rGrid[4],rElementDP[9,2],rHoldDP,rListDP[18],rCross,r,x[4]
boolean b_text[4],b_min[4,4],b_left[4],b_right[4],b_Min0,b_prev,bID[256],bWrapX_[4],b
select pgSel
pointer ptxt
string s,t
for i:=0 to n_obj do
	b_text[i]:=GetBoxInfo(ppg,i,n_text[i],@id_text[i],n_format[i],n_box[i],rTopDP,rBoxDP,rTotalDP,rKotDP,rContDP,rGrid,b_left,b_right,bTabs)
	if b_text[i] then n_reflow[4]+=AddToArray(i,n_reflow,n_reflow[4]) \
		else if bAll then return
end for
for i:=0 to n_obj do
	for j:=0 to n_obj do
		if i=j then continue
		b_min[i,j]:=(rTopDP[i]<rTotalDP[j]) and (rTotalDP[i]>rTopDP[j])
	end for
end for
if bWrapX and (n_text[0]=n_text[n_obj]) then bWrapX_[0]:=b_min[0,n_obj],bWrapX_[n_obj]:=b_min[n_obj,0]
for i:=0 to n_obj do
	if b_text[i] and (b_left[i] or b_right[i]) then iRight:=i,iLeft:=n_obj-i,n_DP:=1,f_id(i,n_obj,id_,rTopDP,rTotalDP,bCross) else continue
	if not (b_left[i] and b_right[i]) then SetElementIndent(ppg,n_text[i],n_box[i],@n_DP,rListDP,@n_element:=0,rElementDP,iElementIT,b_left[i],b_right[i]) ; n_element:=0
	for j:=0 to n_obj do x[j]:=0
	; top
	for j:=n_element:=b_prev:=rHoldDP:=0 to n_obj do
		if f_prev(i,@j,n_obj,@b_prev,b_left[i],b_right[i]) then k:=id_[0,j] else continue
		if b_text[k] and b_min[i,k] then r:=rTopDP[k]-rKotDP[k] else r:=10000
		if not b_prev then rCross:=r,b_min0:=b_min[i,k],b_prev:=1
		b_min0:=GetMax(b_min0,b_min[i,k])
		if rTopDP[i]>=rTotalDP[k] then r:=rCross
		if rTopDP[i]>=(rCross:=GetMin(rCross,r)) then continue
		if (r:=GetMin(GetDepthDiff(rCross,rTopDP[i],(min_space*-1)*b_min0,rGrid[i],1),rBoxDP[i]))<1 then continue
		SetElementVar(k>i,iLeft-(k-i),iRight-(i-k),-1,0,r,@n_element,rElementDP,iElementIT,@n_DP,rListDP)
		x[k]:=r,rHoldDP:=GetMax(r,rHoldDP)
	end for
	; total
	for j:=b_prev:=0 to n_obj do
		if f_prev(i,@j,n_obj,@b_prev,b_left[i],b_right[i]) then k:=id_[1,j] else continue
		if rTopDP[k]>=rTotalDP[i] then r:=0 else r:=rTotalDP[k]+(rContDP[k]*(b_text[k] and b_min[i,k]))
		r:=GetMin(rTotalDP[i],r)-rTopDP[i],rHoldDP:=x[k]
		if not b_prev then rCross:=r,b_min0:=b_min[i,k],b_prev:=1
		b_min0:=GetMax(b_min0,b_min[i,k])
		if (r:=GetMin(GetDepthDiff(rCross:=GetMax(rCross,r),0,min_space*b_min0,rGrid[i],0),rBoxDP[i]))<1 then
			r:=0
			goto X1
		end if
		SetElementVar(k>i,iLeft-(k-i)+1,iRight-(i-k)+1,1,rHoldDP,r,@n_element,rElementDP,iElementIT,@n_DP,rListDP)
		rHoldDP:=r
X1:		if (r:=GetDepthDiff(rBoxDP[i],r,0,0,0)) then \
			SetElementVar(k>i,iLeft-(k-i),iRight-(i-k),-1,rBoxDP[i]-r,rBoxDP[i],@n_element,rElementDP,iElementIT,@n_DP,rListDP)
	end for
	SortVar(rListDP,n_DP,0.0)
	MakeTextBox(ppg,n_text[i],n_box[i],n_DP-=1,rListDP,n_element-=1,rElementDP,iElementIT,iLeft,iRight,b_left[i],b_right[i],bTabs,bWrapX_[i])
end for
for i:=0 to n_reflow[4]-1 do
	k:=n_text[n_reflow[i]],j:=n_format[n_reflow[i]]
	for n:=i-1 downto 0 do if k=n_text[n_reflow[n]] then break
	if n=-1 then n:=id_text[n_reflow[i]] else continue
	GetTextBox ppg^ ID k BOX xBox ELEMENTS xElements ; FORMAT j
	if (b:=getfilestring("format "+(s:=k)+","+(t:=j+1),"border_use",directory+kovezshmira)) then ; box border
		b:=getpasteinfo("id",bID,k+700,ppg^)
		LibFunc(ravprnt1,"BoxBorder")^(n,j+1,ppg,xBox,xElements)
		if not b then PageChange ppg^ ID k+700 LEVEL 1
	else if getpasteinfo("id",bID,k+700,ppg^) then PageChange ppg^ ID k+700 DELETE
	end if
	if not (ptxt:=addr var(str_text_info[n,1],"text")) then continue
	pos:=GetPgPos(nPg,getpage(tail(prevpage(end ptxt^,ptxt^),ptxt^)),ptxt)
	LibFunc(ravbox1,"reflow")^(ppg,nPg,n,this page of range(pos,pos,ptxt^),ptxt^)
	if bool_text_info[n,1] then if LibFunc(ravbreak,"GetFrameSel")^(n,ppg,@pgSel,0) then \ ; cont word
		LibFunc(ravbox2,"PasteContWord")^(n,tail(end pgSel^,ptxt^),xBox,ppg)
end for
END FUNC

FUNC GetBoxInfo(ppg,n,n_text,id_text,n_format,n_box,rTopDP,rBoxDP,rTotalDP,rKotDP,rContDP,rGrid,bLeft,bRight,bTabs)
; textbox var's
int xID,xFormat,xElements[10]
real xBox[9,30],xLeftI[9,4],xRightI[9,4],xYGrid
; script var's
int i
real r
for id_text:=0 to text_count-1 do if kvutsa_textids[id_text]=n_text then break
if id_text=text_count then goto X0
if not getpasteinfo("x",r,n_text,ppg^) then goto X0
GetTextBox ppg^ ID (xID:=n_text) BOX xBox ELEMENTS xElements FORMAT xFormat \
	LINDENT xLeftI RINDENT xRightI YGRID xYGrid
if (xFormat<>n_format) or ((xElements[0]-1)<n_box) then
X0:	rTopDP[n]:=rBoxDP[n]:=rTotalDP[n]:=rKotDP[n]:=rContDP[n]:=rGrid[n]:=0
	return 0
end if
rTopDP[n]:=rTotalDP[n]:=xBox[n_box,1],rBoxDP[n]:=0
for i:=1 to xElements[n_box+1] do rBoxDP[n]+=xBox[n_box,i*3]
rTotalDP[n]+=rBoxDP[n],rKotDP[n]:=GetTextKotDepth(id_text),rContDP[n]:=GetContDepth(id_text,rTotalDP[n]),rGrid[n]:=xYGrid
if bTabs then
	for i:=0 to 3 do if (bLeft[n]:=xLeftI[n_box,i]>0) then break
	for i:=0 to 3 do if (bRight[n]:=xRightI[n_box,i]>0) then break
else bLeft[n]:=bRight[n]:=1
end if
return 1
END FUNC

FUNC GetTextKotDepth(id_text)
int i
real r
pointer pKot
if not (i:=GetPasteInfo("y",r,kvutsa_textids[id_text]+100)) then return 0
libfunc(ravprint,"OpenKoteret")^()
if not (pKot:=addr var(koteret_,"text")) then return 0
return libfunc(ravbreak,"GetTextKotdepth")^(pKot,id_text)
END FUNC

FUNC GetContDepth(id_text,rTotalDP)
int i
real r
if not (i:=GetPasteInfo("y",r,kvutsa_textids[id_text]+300)) then return 0
if (r-=rTotalDP)>0 then return r
return 0
END FUNC

FUNC SetElementVar(bLeft,xLeft,xRight,iType,rStart,rEnd,n_element,rElementDP,iElementIT,n_DP,rListDP)
rElementDP[n_element,0]:=rStart,rElementDP[n_element,1]:=rEnd,n_DP+=AddToArray(rEnd,rListDP,n_DP)
if bLeft then iElementIT[n_element,0]:=xLeft,iElementIT[n_element,1]:=1*iType \
	else iElementIT[n_element,0]:=xRight,iElementIT[n_element,1]:=2*iType
n_element+=1
END FUNC

FUNC MakeTextBox(ppg,n_text,n_box,n_DP,rListDP,n_element,rElementDP,iElementIT,iLeft,iRight,bLeft,bRight,bTabs,bWrapX_)
; textbox var's
int xID,xFormat,xElements[10],xFlags
real xBox[9,30],xLeftI[9,4],xRightI[9,4],xGrid[2],xColI[4]
boolean xHeb
; script var's
int xLeft,xRight,i,j,k,n
real xLeftI_[4],xRightI_[4],rLeft,rRight,rDP
GetTextBox ppg^ ID (xID:=n_text) HEB xHeb BOX xBox ELEMENTS xElements \
	FORMAT xFormat LINDENT xLeftI RINDENT xRightI XGRID xGrid[0] YGRID xGrid[1] \
	COLINDENT xColI FLAGS xFlags
for i:=0 to 3 do xLeftI_[i]:=xLeftI[n_box,i],xRightI_[i]:=xRightI[n_box,i]
if bTabs then
	if bLeft then for i:=1 to 3 do if xLeftI_[i]<xLeftI_[i-1] then xLeftI_[i]:=xLeftI_[i-1]
	if bRight then for i:=1 to 3 do if xRightI_[i]<xRightI_[i-1] then xRightI_[i]:=xRightI_[i-1]
end if
if bWrapX_ then
	if not xLeftI_[0] then xLeftI_[0]:=xLeftI_[1]
	if not xRightI_[0] then xRightI_[0]:=xRightI_[1]
end if
for i:=1 to n_DP do
	xLeft:=-1,xRight:=-1
	for j:=0 to n_element do
		if rListDP[i-1]>=rElementDP[j,0] and rListDP[i]<=rElementDP[j,1] then
			if (GetMask(k:=iElementIT[j,1],1)) then
				if ((k=1)=(iElementIT[j,0]>xLeft)) or (xLeft=-1) then xLeft:=iElementIT[j,0]
			else if ((k=2)=(iElementIT[j,0]>xRight)) or (xRight=-1) then xRight:=iElementIT[j,0]
			end if
		end if
	end for
	if xLeft=-1 then xLeft:=iLeft
	if xRight=-1 then xRight:=iRight
	if not bLeft then rLeft:=GetElementIndent(ppg,n_text,n_box,rListDP[i],1) else rLeft:=xLeftI_[xLeft]
	if not bRight then rRight:=GetElementIndent(ppg,n_text,n_box,rListDP[i],0) else rRight:=xRightI_[xRight]
	rDP:=GetDiff(rListDP[i],rListDP[i-1])
	if i>1 then if xBox[n_box,(i-n-1)*3+1]=rLeft and xBox[n_box,(i-n-1)*3+2]=rRight then \
		n+=1,rDP+=xBox[n_box,(i-n)*3]
	xBox[n_box,(i-n)*3]:=rDP,xBox[n_box,(i-n)*3+1]:=rLeft,xBox[n_box,(i-n)*3+2]:=rRight
end for
xBox[n_box,(i-n)*3]:=0
TextBox ppg^ ID xID HEB xHeb BOX xBox FORMAT xFormat \
	LINDENT xLeftI RINDENT xRightI XGRID xGrid[0] YGRID xGrid[1] \
	COLINDENT xColI FLAGS xFlags
END FUNC

FUNC SetElementIndent(ppg,n_text,n_box,n_DP,rListDP,n_element,rElementDP,iElementIT,bLeft,bRight)
; textbox var's
int xID,xElements[10]
real xBox[9,30]
; script var's
int i,j
real r,x
GetTextBox ppg^ ID (xID:=n_text) BOX xBox ELEMENTS xElements
for i:=1 to xElements[n_box+1] do for j:=0+bRight to 1-bLeft do \
	SetElementVar(j,0,0,1,x:=r,r+=xBox[n_box,i*3],@n_element,rElementDP,iElementIT,@n_DP,rListDP)
END FUNC

FUNC GetElementIndent(ppg,n_text,n_box,rDP,bLeft)
; textbox var's
int xID,xElements[10]
real xBox[9,30]
; script var's
int i
real r
boolean b
GetTextBox ppg^ ID (xID:=n_text) BOX xBox ELEMENTS xElements
for i:=1 to xElements[n_box+1] do \
	if (r+=xBox[n_box,i*3])>=rDP then break
if (i>xElements[n_box+1]) then b:=1
return (r:=xBox[n_box,(i-b)*3+1+(not bLeft)])
END FUNC

FUNC f_prev(i,j,n_obj,b_prev,bLeft,bRight)
boolean b
if j<i then if not bRight then j:=i
if j>i then if (b:=not bLeft) then j:=n_obj
if i=j or b then return (b_prev:=0)
return 1
END FUNC

FUNC f_id(n,n_obj,id_,rTopDP,rTotalDP,bCross) ; 0=top, 1=total ; bCross = top=ascend, total=descend
int nStart,nEnd,i,j,k,m,o
real r_[2,4]
string s,t,u
for j:=0 to n_obj do if j>=n then id_[0,j]:=id_[1,j]:=j else id_[0,j]:=id_[1,j]:=n-(j+1) ; default id_
if not bCross then return
for m:=0 to 1 do
	for o:=0 to 1 do
		if not o then nStart:=0,nEnd:=n-1 else nStart:=n+1,nEnd:=n_obj
		for j:=nStart to nEnd do r_[0,id_[m,j]]:=rTopDP[id_[m,j]],r_[1,id_[m,j]]:=rTotalDP[id_[m,j]] ; default r_
		for i:=nStart to nEnd-1 do
			k:=i
			for j:=i+1 to nEnd do if r_[0,id_[m,SwapVar(k,j,not m)]]>r_[1,id_[m,SwapVar(j,k,not m)]] then k:=j ; top>total
			if k>i then
				s:=id_[m,i],t:=r_[0,id_[m,i]],u:=r_[1,id_[m,i]]
				r_[0,id_[m,i]]:=r_[0,id_[m,k]],r_[1,id_[m,i]]:=r_[1,id_[m,k]],id_[m,i]:=id_[m,k]
				id_[m,k]:=s,r_[0,id_[m,k]]:=t,r_[1,id_[m,k]]:=u
			end if
		end for
	end for
end for
END FUNC

; ***************************************************************************************************

FUNC lib_()
return lib_0(1,1)
END FUNC

FUNC lib_quiet()
return lib_0(0,0)
END FUNC

FUNC lib_0(bMsg,bExit)
return lib_f(ScrFile,"BRC_0",bMsg,bExit)
END FUNC

FUNC lib_f(sFile,sLib,bMsg,bExit)
boolean b
string sMsg
if RunInfo("NAME")="BRC_1" then return 1
if not (addr var(sLib,"lib")) then
	if not isfile(sFile,1) then
		if bMsg then sMsg:="cannot open file "+sFile
		return MsgReturn(sMsg,bExit,0)
	end if
	compile FILE sFile TO sLib ID LibFunc(ravinit,"GetAppID")^()
end if
return (b:=addr var(sLib,"lib"))
END FUNC

FUNC GetScrVersion()
return ScrVersion
END FUNC

FUNC GetDepthDiff(a,b,iAddMin,rGrid,bDown)
real r
r:=a-b+iAddMin
return r+=RoundToGrid(r,rGrid,bDown)
END FUNC

FUNC AddToArray(inValue,inVar,n)
int i
for i:=0 to n-1 do if inValue=inVar[i] then return 0
inVar[n]:=inValue
return 1
END FUNC

; ===================================================================================================

FUNC GetPage_(ppg,nPg,bMsg,bExit)
string sMsg[2],s
if bMsg then sMsg[0]:="no page",sMsg[1]:="no page number"
if not (ppg:=addr activepage()) then return MsgReturn(sMsg[0],bExit,0)
if not (nPg:=range(start find("[0-9]",1,s:=getvarname(ppg^)),len(s),s)) then \
	return MsgReturn(sMsg[1],bExit,0)
return 1
END FUNC

FUNC GetPgPos(iStart,iEnd,p)
int j,pos
if not iEnd then iEnd:=iStart
for j:=iStart to iEnd do if (pos:=findpage(j,p^))>-1 then return pos
return toppage(end p^,p^)
END FUNC

FUNC inSplit(sData,sDelimiter,inVar,iDim1,iDim2,iDim3,iEnd)
int nDim,pos,n
string s
if iDim1>-1 then if iDim2>-1 then if iDim3>-1 \
	then nDim:=3,n:=iDim3 else nDim:=2,n:=iDim2 else nDim:=1,n:=iDim1
if not nDim then return -1
if iEnd=-1 then iEnd:=sizeof(inVar,nDim)
while len(sData) do
	if (pos:=end find(sDelimiter,1,sData))>0 then \
		s:=range(0,pos-1,sData),sData:=tail(pos,sData) else s:=sData,sData:=""
	if nDim=1 then inVar[n]:=s else if nDim=2 then inVar[iDim1,n]:=s \
		else inVar[iDim1,iDim2,n]:=s
	if (n+=1)=iEnd then break
end while
return n
END FUNC

FUNC SortVar(inVar,n,varHolder) ; varHolder: real=0.0,int=0,string=""
int i,j,k,l
if not SizeOf(inVar,1) then return -1
if not n or n>SizeOf(inVar,1) then n:=SizeOf(inVar,1)
for i:=0 to n-2 do
	k:=i
	for j:=i+1 to n-1 do if inVar[k]>inVar[j] then k:=j
	if k>i then varHolder:=inVar[i],inVar[i]:=inVar[k],inVar[k]:=varHolder,l+=1
end for
return l
END FUNC

FUNC SwapVar(a,b,c)
if c then return b
return a
END FUNC

FUNC GetMask(n,iDiv)
return n mod (iDiv*2) div iDiv
END FUNC

FUNC GetMin(a,b)
if a<b then return a
return b
END FUNC

FUNC GetMax(a,b)
if a>b then return a
return b
END FUNC

FUNC GetDiff(a,b)
return a-b
END FUNC

FUNC RoundToGrid(n,rGrid,bDown)
real r
if not (rGrid and n) then return 0
if bDown then r:=(n mod rGrid)*-1 else r:=(rGrid-(n mod rGrid)) mod rGrid
return r
END FUNC

FUNC rStr(s)
reverse s
return s
END FUNC

FUNC MsgReturn(sMsg,bExit,xReturn)
if sMsg then msg sMsg
if bExit then exit
return xReturn
END FUNC

FUNC TagVersion_(rVersion)
int v[2]
real r
string s
TagVersion v[0],v[1]
return rVersion<=(r:=(s:=v[0])+"."+(s:=v[1]))
END FUNC

FUNC GetDlgColor(n)
int i,j,k[3],m
string s
for i:=len(s:=n) to 2 do s:="0"+s
k[0]:=32,k[1]:=32*256,k[2]:=32*65536
for i:=1 to 3 do if (j:=range(i-1,i,s))<8 then m+=(j*k[i-1])
return m
END FUNC

; +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

FUNC Set_(id_set,bDel)
boolean bReturn
string s,t,u
t:=GetFS("set "+(s:=id_set),"text","")
if (u:=GetFS("set "+s,"shem",""))=" " then u:=""
if not (bReturn:=(t or u)) then if bDel then SetFS("set "+s,0,0,1)
return bReturn
END FUNC

FUNC Kvuza_(id_kvuza,bDel)
boolean bReturn
string s,t,u
t:=GetFS("kvuza "+(s:=id_kvuza),"sets","")
if (u:=GetFS("kvuza "+s,"shem",""))=" " then u:=""
if not (bReturn:=(t or u)) then if bDel then SetFS("kvuza "+s,0,0,1)
return bReturn
END FUNC

FUNC bIniFile(sDir)
if not IsFile(iniFile,1) then create sDir+iniFile
return IsFile(iniFile,1)
END FUNC

FUNC SetIniFile_pos(sDialog,sKey)
int i,j
string s
if not bIniFile(getdlgtext(d_berech,2001)) then return
if not sKey then sKey:=sDialog+"XY"
if GetWindowPos(var(sDialog,"dlog"),i,j)=2 then SetFS(iniSection,sKey,(s:=i)+","+(s:=j),0)
END FUNC

FUNC GetIniFile_pos(sDialog,sKey)
int i,j
string s
if not sKey then sKey:=sDialog+"XY"
i:=s:=GetFS(iniSection,sKey,"-1,-1")
if (j:=end find(",",0,s))>-1 then j:=tail(j,s)
show var(sDialog,"dlog") at i,j
END FUNC

FUNC SetIniFile_Info(sSet,sKvuza)
int i,j
string sKey[3],s,t
if not bIniFile(getdlgtext(d_berech,2001)) then return 0
if sKvuza then goto X0
SetFS(sSet,"shem",getdlgtext(d_berech_SetInfo,10),0)
sKey[0]:="text",sKey[1]:="format",sKey[2]:="box"
for i:=1 to 3 do
	j:=1,t:=""
	while (s:=getdlgtext(d_berech_SetInfo,100*i+j)) do t+=s+",",j+=1
	SetFS(sSet,sKey[i-1],s:=range(0,(j:=len(t))-(j>0),t),0)
end for
SetFS(sSet,"swap",s:=getcheck(d_berech_SetInfo,401),0)
SetFS(sSet,"all",s:=getcheck(d_berech_SetInfo,402),0)
SetFS(sSet,"min_space",getdlgtext(d_berech_SetInfo,403),0)
goto X1
X0:	SetFS(sKvuza,"shem",getdlgtext(d_berech_KvuzaInfo,10),0)
	SetFS(sKvuza,"sets",getdlgtext(d_berech_KvuzaInfo,11),0)
X1:	return 1
END FUNC

FUNC GetIniFile_Info(sSet,sKvuza)
int set_info[3,4],n_obj,i,j
string s
if sKvuza then goto X0
setdlgtext(d_berech_SetInfo,10,GetFS(sSet,"shem"," "))
s:=GetFS(sSet,"text",""),n_obj:=inSplit(s,",",set_info,0,0,-1,-1)-1
s:=GetFS(sSet,"format",""),inSplit(s,",",set_info,1,0,-1,-1)
s:=GetFS(sSet,"box",""),inSplit(s,",",set_info,2,0,-1,-1)
for i:=0 to 2 do for j:=0 to n_obj do setdlgtext(d_berech_SetInfo,100*(i+1)+(j+1),s:=set_info[i,j])
setcheck(d_berech_SetInfo,401,i:=GetAltFS(sSet,iniSection,"swap"))
setcheck(d_berech_SetInfo,402,i:=GetAltFS(sSet,iniSection,"all"))
setdlgtext(d_berech_SetInfo,403,GetAltFS(sSet,iniSection,"min_space"))
return
X0:	setdlgtext(d_berech_KvuzaInfo,10,GetFS(sKvuza,"shem"," "))
	setdlgtext(d_berech_KvuzaInfo,11,GetFS(sKvuza,"sets",""))
END FUNC

FUNC SetFS(sSection,xKey,xValue,bDelete)
if xValue or not bDelete then setfilestring(sSection,xKey,xValue,iniFile) \
	else setfilestring(sSection,xKey,0,iniFile)
END FUNC

FUNC GetFS(sSection,sKey,sDefault)
string s
if not (s:=getfilestring(sSection,sKey,iniFile)) then s:=sDefault
return s
END FUNC

FUNC GetAltFS(sSection,sAltSection,sKey)
string s
if (s:=getfilestring(sSection,sKey,iniFile)) then return s
return (s:=getfilestring(sAltSection,sKey,iniFile))
END FUNC

FUNC GetAltFS_(sSection,sAltSection,sKey,sDefault)
string s
if (s:=getfilestring(sSection,sKey,iniFile)) then return s
if not (s:=getfilestring(sAltSection,sKey,iniFile)) then s:=sDefault
return s
END FUNC

; ---------------------------------------------------------------------------------------------------

FUNC Main()
END FUNC

FUNC Info()
END FUNC

; ---------------------------------------------------------------------------------------------------

FUNC GetLib() ; LC/RTA
if not var("d_linkcalc") then return 0
if var("LC_0","lib") then return LibFunc(LC_0,"LinkCalc_r")
if var("RAVAID1","lib") then return LibFunc(RAVAID1,"LinkCalc_r")
END FUNC
